{-# LANGUAGE TemplateHaskell     #-}


module Phoityne.IO.GUI.VSCode.TH.DisconnectResponseJSON where

import Data.Aeson.TH

import Phoityne.Utility
import Phoityne.IO.GUI.VSCode.TH.DisconnectRequestJSON

-- |
--   Response to "disconnect" request. This is just an acknowledgement, so no body field is required.
--
data DisconnectResponse =
  DisconnectResponse {
    seqDisconnectResponse         :: Int     -- Sequence number
  , typeDisconnectResponse        :: String  -- One of "request", "response", or "event"
  , request_seqDisconnectResponse :: Int     -- Sequence number of the corresponding request
  , successDisconnectResponse     :: Bool    -- Outcome of the request
  , commandDisconnectResponse     :: String  -- The command requested 
  , messageDisconnectResponse     :: String  -- Contains error message if success == false.
  } deriving (Show, Read, Eq)

$(deriveJSON defaultOptions { fieldLabelModifier = rdrop (length "DisconnectResponse") } ''DisconnectResponse)

-- |
--
defaultDisconnectResponse :: Int -> DisconnectRequest ->  DisconnectResponse
defaultDisconnectResponse seq (DisconnectRequest reqSeq _ _ _) =
  DisconnectResponse seq "response" reqSeq True "disconnect" ""
