{-# LANGUAGE TemplateHaskell #-}


module Phoityne.IO.GUI.VSCode.TH.InitializeResponseJSON where

import Data.Aeson.TH

import Phoityne.Utility
import Phoityne.IO.GUI.VSCode.TH.InitializeResponseCapabilitesJSON

-- |
--   Server-initiated response to client request
--
data InitializeResponse =
  InitializeResponse {
    seqInitializeResponse         :: Int     -- Sequence number
  , typeInitializeResponse        :: String  -- One of "request", "response", or "event"
  , request_seqInitializeResponse :: Int     -- Sequence number of the corresponding request
  , successInitializeResponse     :: Bool    -- Outcome of the request
  , commandInitializeResponse     :: String  -- The command requested 
  , messageInitializeResponse     :: String  -- Contains error message if success == false.
  , bodyInitializeResponse        :: InitializeResponseCapabilites  -- The capabilities of this debug adapter
  } deriving (Show, Read, Eq)

$(deriveJSON defaultOptions { fieldLabelModifier = rdrop (length "InitializeResponse") } ''InitializeResponse)
